import {
  GdsFlex
} from "./chunk.NVBMHHKJ.js";
import {
  styleExpressionProperty
} from "./chunk.K4KPKUH4.js";
import {
  tokens
} from "./chunk.LVFKJRDS.js";
import {
  gdsCustomElement
} from "./chunk.QK3R23GV.js";
import {
  __decorateClass
} from "./chunk.SEHSDSX2.js";

// libs/core/src/components/mask/mask.ts
import { html } from "lit/static-html.js";

// libs/core/src/components/mask/mask.style.ts
import { css } from "lit";
var style = css`
  :host {
    isolation: isolate;
  }

  [part='mask'] {
    position: absolute;
    inset: 0;
    z-index: -1;
    pointer-events: none;
  }

  [part='content'] {
    z-index: 1;
    position: absolute;
    inset: 0;
  }
`;
var mask_style_default = style;

// libs/core/src/components/mask/mask.ts
var GdsMask = class extends GdsFlex {
  constructor() {
    super();
    this["mask-size"] = "cover";
    this["mask-repeat"] = "no-repeat";
    this["mask-position"] = "center";
    this.position = "relative";
    this.inset = "0";
  }
  render() {
    return html`<div part="mask"></div>
      <div part="content"><slot></slot></div>`;
  }
};
GdsMask.styles = [tokens, mask_style_default];
__decorateClass([
  styleExpressionProperty({
    selector: '[part="mask"]',
    valueTemplate: (v) => {
      const [direction] = v.split("/");
      return `linear-gradient(to ${direction}, rgba(0, 0, 0, 1) 20%, rgba(0, 0, 0, 0) 100%)`;
    }
  })
], GdsMask.prototype, "mask-image", 2);
__decorateClass([
  styleExpressionProperty({
    valueTemplate: (v) => v,
    selector: '[part="mask"]'
  })
], GdsMask.prototype, "mask-size", 2);
__decorateClass([
  styleExpressionProperty({
    valueTemplate: (v) => v,
    selector: '[part="mask"]'
  })
], GdsMask.prototype, "mask-repeat", 2);
__decorateClass([
  styleExpressionProperty({
    valueTemplate: (v) => v,
    selector: '[part="mask"]'
  })
], GdsMask.prototype, "mask-position", 2);
__decorateClass([
  styleExpressionProperty({
    selector: '[part="mask"]',
    valueTemplate: function(v) {
      const [backgroundColor, backgroundColorAlpha] = v.split("/");
      const background = backgroundColorAlpha ? `color-mix(in srgb, var(--gds-color-${"l" + this.level}-background-${backgroundColor}) ${parseFloat(backgroundColorAlpha) * 100}%, transparent 0%)` : `var(--gds-color-${"l" + this.level}-background-${backgroundColor})`;
      return background;
    }
  })
], GdsMask.prototype, "background-color", 2);
__decorateClass([
  styleExpressionProperty({
    valueTemplate: (v) => v,
    selector: '[part="mask"]'
  })
], GdsMask.prototype, "backdrop-filter", 2);
GdsMask = __decorateClass([
  gdsCustomElement("gds-mask")
], GdsMask);

export {
  GdsMask
};
