import {
  defaultStyles
} from "./chunk.UEJZWDMS.js";
import {
  GdsContainer
} from "./chunk.CIUHRMH7.js";
import {
  styleExpressionProperty
} from "./chunk.K4KPKUH4.js";
import {
  tokens
} from "./chunk.LVFKJRDS.js";
import {
  gdsCustomElement
} from "./chunk.QK3R23GV.js";
import {
  __decorateClass
} from "./chunk.SEHSDSX2.js";

// libs/core/src/components/text/text.ts
import { property } from "lit/decorators.js";
import { html, unsafeStatic } from "lit/static-html.js";

// libs/core/src/components/text/text.style.ts
import { css } from "lit";
var style = css`
  :host {
    display: block;
  }

  [tag] {
    margin: 0;
    padding: 0;
    text-underline-offset: 0.2lh;
  }
`;
var text_style_default = style;

// libs/core/src/components/text/text.ts
var GdsText = class extends GdsContainer {
  constructor() {
    super(...arguments);
    this.level = "2";
    this.tag = "span";
  }
  render() {
    const TAG = unsafeStatic(encodeURI(this.tag));
    return html`<${TAG} tag><slot></slot></${TAG}>`;
  }
};
GdsText.styles = [tokens, defaultStyles, text_style_default];
__decorateClass([
  property()
], GdsText.prototype, "level", 2);
__decorateClass([
  property({ type: String })
], GdsText.prototype, "tag", 2);
__decorateClass([
  styleExpressionProperty({
    valueTemplate: (v) => `${v}`,
    selector: "[tag]",
    styleTemplate: (prop, values) => {
      const size = values[0];
      const styleSize = `font-size: var(--gds-text-size-${size});`;
      const styleLine = `line-height: var(--gds-text-line-height-${size});`;
      return styleSize + styleLine;
    }
  })
], GdsText.prototype, "font-size", 2);
__decorateClass([
  styleExpressionProperty({
    property: "font-weight",
    selector: "[tag]",
    valueTemplate: (v) => `var(--gds-text-weight-${v})`
  })
], GdsText.prototype, "font-weight", 2);
__decorateClass([
  styleExpressionProperty({
    property: "text-wrap",
    valueTemplate: (v) => v
  })
], GdsText.prototype, "text-wrap", 2);
__decorateClass([
  styleExpressionProperty({
    property: "text-transform",
    valueTemplate: (v) => v
  })
], GdsText.prototype, "text-transform", 2);
__decorateClass([
  styleExpressionProperty({
    property: "text-align",
    valueTemplate: (v) => v
  })
], GdsText.prototype, "text-align", 2);
__decorateClass([
  styleExpressionProperty({
    valueTemplate: (v) => v,
    selector: "[tag]"
  })
], GdsText.prototype, "text-decoration", 2);
__decorateClass([
  styleExpressionProperty({
    valueTemplate: (v) => v,
    styleTemplate: (_prop, values) => {
      return `overflow: hidden;
      text-overflow: ellipsis;
      display: -webkit-box;
      -webkit-line-clamp: ${values[0]};
      -webkit-box-orient: vertical;`;
    }
  })
], GdsText.prototype, "lines", 2);
__decorateClass([
  styleExpressionProperty({
    property: "color",
    valueTemplate: function(v) {
      const [colorName, transparency] = v.split("/");
      if (transparency) {
        return `color-mix(in srgb, var(--gds-color-${"l" + this.level}-content-${colorName}) ${parseFloat(transparency) * 100}%, transparent 0%)`;
      } else {
        return `var(--gds-color-${"l" + this.level}-content-${colorName})`;
      }
    }
  })
], GdsText.prototype, "color", 2);
GdsText = __decorateClass([
  gdsCustomElement("gds-text")
], GdsText);

export {
  GdsText
};
