import {
  GdsFormControlElement
} from "./chunk.VA6TUMR2.js";
import {
  observeLightDOM
} from "./chunk.WM7HBMMV.js";
import {
  watch
} from "./chunk.TYGMNHNO.js";
import {
  tokens
} from "./chunk.LVFKJRDS.js";
import {
  gdsCustomElement,
  html
} from "./chunk.QK3R23GV.js";
import {
  __decorateClass,
  __privateAdd,
  __privateGet,
  __privateMethod,
  __privateSet
} from "./chunk.SEHSDSX2.js";

// libs/core/src/components/dropdown/dropdown.ts
import { localized, msg, str } from "@lit/localize";
import { property, query, queryAsync } from "lit/decorators.js";
import { ifDefined } from "lit/directives/if-defined.js";
import { unsafeHTML } from "lit/directives/unsafe-html.js";
import { when } from "lit/directives/when.js";

// libs/core/src/components/dropdown/dropdown.styles.ts
import { css } from "lit";
var style = css`
  @layer base, reset;

  @layer base {
    :host {
      display: flex;
      flex-direction: column;
      width: 100%;
      gap: var(--gds-space-xs);
      contain: layout;
      isolation: isolate;
      --_transition: all 368ms cubic-bezier(0.4, 0, 0.2, 1);
    }

    #field::part(_base) {
      cursor: pointer;
    }

    button {
      appearance: none;
      background: transparent;
      border-width: 0;
      font-family: inherit;
      font-size: inherit;
      line-height: inherit;
      color: currentColor;
      cursor: pointer;
      padding: 0;
      text-align: left;
      flex: 0 1 100%;

      /* This prevents overflow when the text is too long */
      display: grid;
    }

    button:focus {
      outline: none;
    }

    slot[name='trigger'] > span {
      display: block;
      overflow: hidden;
      text-overflow: ellipsis;
      white-space: nowrap;
    }

    input[type='text'] {
      border-radius: var(--gds-space-xs);
      border-bottom-left-radius: 0;
      border-bottom-right-radius: 0;
      font-size: inherit;
      line-height: inherit;
      border: none;
      outline: none;
      color: var(--gds-color-l3-content-disabled);
      border-color: var(--gds-color-l3-border-tertiary);
      border-width: 0 0 var(--gds-space-4xs) 0;
      border-style: solid;
      width: 100%;
      padding: var(--gds-space-m);
      font-weight: var(--gds-text-weight-regular);
      flex: 1;
      box-sizing: border-box;
      font-family: inherit;

      &:focus {
        border-color: var(--gds-color-l3-border-secondary);
        color: var(--gds-color-l3-content-tertiary);
      }

      &::placeholder {
        font-family: inherit;
        font-weight: var(--gds-text-weight-book);
        color: var(--gds-color-l3-content-disabled);
      }
    }

    input[role='combobox'] {
      appearance: none;
      background: transparent;
      border: none;
      font-size: inherit;
      outline: none;
    }

    [aria-expanded='true'] [slot='trail'] {
      transform: scaleY(-1);
    }
  }
`;
var dropdown_styles_default = style;

// libs/core/src/components/dropdown/dropdown.ts
var _optionElements, _renderCombobox, _renderTriggerButton, _calcMaxHeight, _handleSearchFieldInput, _handleSearchFieldKeyDown, _handleListboxKeyDown, _handleOptionFocusChange, _handleSelectionChange, handleSelectionChange_fn, _registerAutoCloseListener, registerAutoCloseListener_fn, _unregisterAutoCloseListener, unregisterAutoCloseListener_fn, _blurCloseListener, _tabCloseListener;
var GdsDropdown = class extends GdsFormControlElement {
  constructor() {
    super(...arguments);
    /**
     * Selects an option in the dropdown.
     *
     * @fires change
     */
    __privateAdd(this, _handleSelectionChange);
    __privateAdd(this, _registerAutoCloseListener);
    __privateAdd(this, _unregisterAutoCloseListener);
    this.supportingText = "";
    this.open = false;
    this.searchable = false;
    this.multiple = false;
    this.combobox = false;
    this.compareWith = (a, b) => a === b;
    this.searchFilter = (q, o) => o.innerHTML.toLowerCase().includes(q.toLowerCase());
    this.syncPopoverWidth = false;
    this.maxHeight = 500;
    this.size = "medium";
    this.hideLabel = false;
    this.disableMobileStyles = false;
    __privateAdd(this, _optionElements, void 0);
    __privateAdd(this, _renderCombobox, () => {
      var _a;
      return html`
      <input
        id="trigger"
        role="combobox"
        aria-expanded="${this.open}"
        aria-owns="listbox"
        aria-haspopup="listbox"
        aria-controls="listbox"
        placeholder="${(_a = this.placeholder) == null ? void 0 : _a.innerHTML}"
        name="trigger"
        aria-label="${this.label} ${this.displayValue}"
        aria-describedby="supporting-text extended-supporting-text sub-label message"
        aria-invalid="${this.invalid}"
        aria-required="${this.required}"
        aria-disabled="${this.disabled}"
        .value=${this.value}
        @click=${(e) => {
        e.stopImmediatePropagation();
      }}
        @input=${(e) => {
        this.value = e.target.value;
        __privateGet(this, _handleSearchFieldInput).call(this, e);
        this.open = true;
      }}
        @keydown=${(e) => {
        if (e.key === "ArrowDown") {
          e.preventDefault();
          this.open = true;
          this._elListbox.then((listbox) => listbox.focus());
        }
      }}
      />
    `;
    });
    __privateAdd(this, _renderTriggerButton, () => {
      return html`
      <button
        id="trigger"
        role="combobox"
        aria-expanded="${this.open}"
        aria-owns="listbox"
        aria-haspopup="listbox"
        aria-controls="listbox"
        name="trigger"
        aria-label="${this.label} ${this.displayValue}"
        aria-describedby="supporting-text extended-supporting-text sub-label message"
        aria-invalid="${this.invalid}"
        aria-required="${this.required}"
        aria-disabled="${this.disabled}"
      >
        <slot name="trigger">
          <span>${unsafeHTML(this.displayValue)}</span>
        </slot>
      </button>
    `;
    });
    __privateAdd(this, _calcMaxHeight, (trigger) => {
      const triggerRect = trigger.getBoundingClientRect();
      const windowHeight = window.innerHeight;
      const bottomSpace = windowHeight - triggerRect.bottom;
      const topSpace = triggerRect.top;
      let height = Math.min(topSpace, this.maxHeight);
      if (bottomSpace > topSpace)
        height = Math.min(bottomSpace, this.maxHeight);
      return `${height - 16}px`;
    });
    /**
     * Event handler for filtering the options in the dropdown.
     *
     * @param e The input event.
     */
    __privateAdd(this, _handleSearchFieldInput, (e) => {
      if (!e.currentTarget)
        return;
      e.stopPropagation();
      const wasCancelled = !this.dispatchEvent(
        new CustomEvent("gds-filter-input", {
          detail: { value: e.currentTarget.value },
          cancelable: true
        })
      );
      if (wasCancelled)
        return;
      const input = e.currentTarget;
      this.options.forEach((o) => o.hidden = false);
      if (!input.value)
        return;
      const filteredOptions = this.options.filter(
        (o) => !this.searchFilter(input.value, o)
      );
      filteredOptions.forEach((o) => o.hidden = true);
    });
    /**
     * Check for ArrowDown or Tab in the search field.
     * If found, focus should be moved to the listbox.
     */
    __privateAdd(this, _handleSearchFieldKeyDown, (e) => {
      var _a;
      (_a = this._elListbox) == null ? void 0 : _a.then((listbox) => {
        if (e.key === "ArrowDown" || e.key === "Tab") {
          e.preventDefault();
          listbox.focus();
          return;
        }
      });
    });
    /**
     * Check for Tab in the listbox.
     * If found, focus should be moved to the search field.
     */
    __privateAdd(this, _handleListboxKeyDown, (e) => {
      var _a;
      if (e.key === "Tab" && this.searchable) {
        e.preventDefault();
        (_a = this._elSearchInput) == null ? void 0 : _a.focus();
        return;
      }
    });
    __privateAdd(this, _handleOptionFocusChange, (e) => {
      const triggerButton = this._elTriggerBtn;
      if (triggerButton)
        triggerButton.ariaActiveDescendantElement = e.target;
    });
    /**
     * A listener to close the dropdown when any other element is focused.
     */
    __privateAdd(this, _blurCloseListener, (e) => {
      const isFocusOutside = e instanceof FocusEvent && e.relatedTarget && !this.contains(e.relatedTarget);
      if (isFocusOutside)
        this.open = false;
    });
    __privateAdd(this, _tabCloseListener, (e) => {
      var _a;
      if (e.key === "Tab" && !this.searchable) {
        e.preventDefault();
        this.open = false;
        (_a = this._elTriggerBtn) == null ? void 0 : _a.focus();
      }
    });
  }
  get type() {
    return "gds-dropdown";
  }
  /**
   * Get the options of the dropdown.
   */
  get options() {
    if (!__privateGet(this, _optionElements))
      return [];
    return Array.from(__privateGet(this, _optionElements)).filter(
      (o) => !o.hasAttribute("isplaceholder")
    );
  }
  /**
   * Return the first option with a isPlaceholder attribute.
   * If no placeholder is found, this will be undefined.
   */
  get placeholder() {
    if (!__privateGet(this, _optionElements))
      return;
    return Array.from(__privateGet(this, _optionElements)).find(
      (o) => o.hasAttribute("isplaceholder")
    );
  }
  /**
   * Returns the display value as a string.
   * If the dropdown is in multiple mode, this will be a comma separated list of the selected values.
   */
  get displayValue() {
    var _a, _b;
    let displayValue;
    if (Array.isArray(this.value)) {
      this.value.length > 2 ? displayValue = msg(str`${this.value.length} selected`) : displayValue = this.value.reduce(
        (acc, cur) => {
          var _a2;
          return acc + ((_a2 = this.options.find((v) => v.value === cur)) == null ? void 0 : _a2.innerHTML) + ", ";
        },
        ""
      ).slice(0, -2);
    } else {
      displayValue = (_a = this.options.find((v) => v.selected)) == null ? void 0 : _a.innerHTML;
    }
    return displayValue || ((_b = this.placeholder) == null ? void 0 : _b.innerHTML) || "";
  }
  /**
   * Moves focus to this element.
   */
  focus() {
    this._getValidityAnchor().focus();
  }
  /**
   * A reference to the field element. This does not refer to the trigger button element itself,
   * but the wrapper that makes up the visual field.
   * Intended for use in integration tests.
   */
  test_getFieldElement() {
    var _a;
    return (_a = this.shadowRoot) == null ? void 0 : _a.querySelector("#field");
  }
  connectedCallback() {
    super.connectedCallback();
    this.updateComplete.then(() => {
      this._handleLightDOMChange();
      this._handleValueChange();
    });
  }
  render() {
    return html`
      ${when(
      !this.hideLabel,
      () => html`
          <gds-form-control-header class="size-${this.size}">
            <label id="label" for="trigger" slot="label">${this.label}</label>
            ${when(
        this.supportingText.length > 0,
        () => html`<span slot="supporting-text" id="supporting-text">
                  ${this.supportingText}
                </span>`
      )}
            <slot
              id="extended-supporting-text"
              name="extended-supporting-text"
              slot="extended-supporting-text"
            ></slot>
            <!-- @deprecated: use 'supporting-text' slot instead. Remove in 2.0 release. -->
            <slot id="sub-label" name="sub-label" slot="supporting-text"></slot>
          </gds-form-control-header>
        `
    )}
      <gds-popover
        .autofocus=${!this.combobox}
        .label=${this.label}
        .open=${this.open}
        .calcMaxWidth=${(trigger) => this.syncPopoverWidth ? `${trigger.offsetWidth}px` : `auto`}
        .calcMaxHeight=${__privateGet(this, _calcMaxHeight)}
        .disableMobileStyles=${this.disableMobileStyles || this.combobox}
        .nonmodal=${this.combobox}
        @gds-ui-state=${(e) => this.open = e.detail.open}
      >
        <gds-field-base
          .size=${this.size}
          .disabled=${this.disabled}
          .invalid=${this.invalid}
          slot="trigger"
          id="field"
        >
          <slot name="lead" slot="lead"></slot>
          ${this.combobox && !this.multiple ? __privateGet(this, _renderCombobox).call(this) : __privateGet(this, _renderTriggerButton).call(this)}
          <gds-icon-chevron-bottom slot="trail"></gds-icon-chevron-bottom>
        </gds-field-base>

        ${when(
      this.searchable,
      () => html`<input
              id="searchinput"
              type="text"
              aria-label="${msg("Filter available options")}"
              placeholder="${msg("Search")}"
              @keydown=${__privateGet(this, _handleSearchFieldKeyDown)}
              @input=${__privateGet(this, _handleSearchFieldInput)}
            />`
    )}
        <gds-listbox
          id="listbox"
          .multiple="${ifDefined(this.multiple)}"
          .compareWith="${this.compareWith}"
          @change="${__privateMethod(this, _handleSelectionChange, handleSelectionChange_fn)}"
          @gds-focus="${__privateGet(this, _handleOptionFocusChange)}"
          @keydown=${__privateGet(this, _handleListboxKeyDown)}
        >
          <slot></slot>
        </gds-listbox>
      </gds-popover>

      ${when(
      !this.hideLabel,
      () => html`
          <gds-form-control-footer class="size-${this.size}">
            ${when(
        this.invalid,
        // @deprecated
        // Wrapped in a slot for backwards compatibility with the deprecated message slot
        // Remove for 2.0 release
        () => html`
                <slot id="message" name="message" slot="message">
                  <gds-icon-triangle-exclamation
                    solid
                  ></gds-icon-triangle-exclamation>
                  ${this.errorMessage || this.validationMessage}
                </slot>
              `
      )}
          </gds-form-control-footer>
        `
    )}
    `;
  }
  _getValidityAnchor() {
    return this._elTriggerBtn;
  }
  _handleLightDOMChange() {
    var _a, _b;
    this.requestUpdate();
    __privateSet(this, _optionElements, this.querySelectorAll("[gds-element=gds-option]"));
    if (this.multiple) {
      this._handleValueChange();
      return;
    }
    if (this.value === void 0) {
      if (this.placeholder)
        this.value = this.placeholder.value;
      else
        this.value = (_a = this.options[0]) == null ? void 0 : _a.value;
    } else if (!this.placeholder && this.options.find(
      (o) => this.compareWith(o.value, this.value)
    ) === void 0) {
      this.options[0] && (this.options[0].selected = true);
      this.value = (_b = this.options[0]) == null ? void 0 : _b.value;
    }
  }
  _handleValueChange() {
    this._elListbox.then((listbox) => {
      if (listbox) {
        if (Array.isArray(this.value))
          listbox.selection = this.value;
        else
          listbox.selection = [this.value];
      }
    });
  }
  _onOpenChange() {
    var _a;
    const open = this.open;
    (_a = __privateGet(this, _optionElements)) == null ? void 0 : _a.forEach((o) => o.hidden = !open);
    if (open)
      __privateMethod(this, _registerAutoCloseListener, registerAutoCloseListener_fn).call(this);
    else {
      __privateMethod(this, _unregisterAutoCloseListener, unregisterAutoCloseListener_fn).call(this);
      this._elSearchInput && (this._elSearchInput.value = "");
    }
    const selectedOption = this.options.find((option) => option.selected);
    this.updateComplete.then(() => selectedOption == null ? void 0 : selectedOption.scrollIntoView());
    this.dispatchEvent(
      new CustomEvent("gds-ui-state", {
        detail: { open },
        bubbles: true,
        composed: true
      })
    );
  }
};
_optionElements = new WeakMap();
_renderCombobox = new WeakMap();
_renderTriggerButton = new WeakMap();
_calcMaxHeight = new WeakMap();
_handleSearchFieldInput = new WeakMap();
_handleSearchFieldKeyDown = new WeakMap();
_handleListboxKeyDown = new WeakMap();
_handleOptionFocusChange = new WeakMap();
_handleSelectionChange = new WeakSet();
handleSelectionChange_fn = function() {
  this._elListbox.then((listbox) => {
    var _a;
    if (this.multiple)
      this.value = listbox.selection.map((s) => s.value);
    else {
      this.value = (_a = listbox.selection[0]) == null ? void 0 : _a.value;
      this.open = false;
      this.dispatchEvent(
        new Event("input", {
          bubbles: true,
          composed: true
        })
      );
      setTimeout(() => {
        var _a2;
        return (_a2 = this._elTriggerBtn) == null ? void 0 : _a2.focus();
      }, 0);
    }
    this.dispatchEvent(
      new CustomEvent("change", {
        detail: { value: this.value },
        bubbles: true,
        composed: true
      })
    );
  });
};
_registerAutoCloseListener = new WeakSet();
registerAutoCloseListener_fn = function() {
  this.addEventListener("blur", __privateGet(this, _blurCloseListener));
  this.addEventListener("gds-blur", __privateGet(this, _blurCloseListener));
  this.addEventListener("keydown", __privateGet(this, _tabCloseListener));
};
_unregisterAutoCloseListener = new WeakSet();
unregisterAutoCloseListener_fn = function() {
  this.removeEventListener("blur", __privateGet(this, _blurCloseListener));
  this.removeEventListener("gds-blur", __privateGet(this, _blurCloseListener));
  this.removeEventListener("keydown", __privateGet(this, _tabCloseListener));
};
_blurCloseListener = new WeakMap();
_tabCloseListener = new WeakMap();
GdsDropdown.styles = [tokens, dropdown_styles_default];
__decorateClass([
  property({ attribute: "supporting-text" })
], GdsDropdown.prototype, "supportingText", 2);
__decorateClass([
  property({ type: Boolean, reflect: true })
], GdsDropdown.prototype, "open", 2);
__decorateClass([
  property({ type: Boolean, reflect: true })
], GdsDropdown.prototype, "searchable", 2);
__decorateClass([
  property({ type: Boolean, reflect: true })
], GdsDropdown.prototype, "multiple", 2);
__decorateClass([
  property({ type: Boolean, reflect: true })
], GdsDropdown.prototype, "combobox", 2);
__decorateClass([
  property()
], GdsDropdown.prototype, "compareWith", 2);
__decorateClass([
  property()
], GdsDropdown.prototype, "searchFilter", 2);
__decorateClass([
  property({ type: Boolean, attribute: "sync-popover-width" })
], GdsDropdown.prototype, "syncPopoverWidth", 2);
__decorateClass([
  property({ type: Number, attribute: "max-height" })
], GdsDropdown.prototype, "maxHeight", 2);
__decorateClass([
  property()
], GdsDropdown.prototype, "size", 2);
__decorateClass([
  property({ type: Boolean, attribute: "hide-label" })
], GdsDropdown.prototype, "hideLabel", 2);
__decorateClass([
  property()
], GdsDropdown.prototype, "disableMobileStyles", 2);
__decorateClass([
  query("#trigger")
], GdsDropdown.prototype, "_elTriggerBtn", 2);
__decorateClass([
  queryAsync("#listbox")
], GdsDropdown.prototype, "_elListbox", 2);
__decorateClass([
  query("#searchinput")
], GdsDropdown.prototype, "_elSearchInput", 2);
__decorateClass([
  observeLightDOM({
    attributes: true,
    childList: true,
    subtree: true,
    characterData: true
  })
], GdsDropdown.prototype, "_handleLightDOMChange", 1);
__decorateClass([
  watch("value")
], GdsDropdown.prototype, "_handleValueChange", 1);
__decorateClass([
  watch("open")
], GdsDropdown.prototype, "_onOpenChange", 1);
GdsDropdown = __decorateClass([
  gdsCustomElement("gds-dropdown"),
  localized()
], GdsDropdown);

export {
  GdsDropdown
};
