import {
  TransitionalStyles
} from "./chunk.IEWLS75F.js";
import {
  GdsElement
} from "./chunk.TMEWQZER.js";
import {
  gdsCustomElement
} from "./chunk.QK3R23GV.js";
import {
  __decorateClass
} from "./chunk.SEHSDSX2.js";

// libs/core/src/primitives/menu/menu-heading.ts
import { html } from "lit";

// libs/core/src/primitives/menu/menu-heading.styles.ts
import { css } from "lit";
var style = css`
  @layer base, reset, transitional-styles;
  @layer base {
    :host {
      cursor: pointer;
      color: var(--gds-color-l3-content-secondary);
      background-color: var(--gds-color-l3-background-secondary);
      font-size: var(--gds-text-size-label-input-medium);
      line-height: var(--gds-text-line-height-label-input-medium);
      padding-inline: var(--gds-space-m);
      padding-block: var(--gds-space-xs);
    }
  }
`;
var menu_heading_styles_default = style;

// libs/core/src/primitives/menu/menu-heading.ts
var GdsMenuHeading = class extends GdsElement {
  connectedCallback() {
    super.connectedCallback();
    this.setAttribute("inert", "true");
    this.updateComplete.then(
      () => TransitionalStyles.instance.apply(this, "gds-menu-heading")
    );
  }
  render() {
    return html`<slot></slot>`;
  }
};
GdsMenuHeading.styles = menu_heading_styles_default;
GdsMenuHeading = __decorateClass([
  gdsCustomElement("gds-menu-heading")
], GdsMenuHeading);

export {
  GdsMenuHeading
};
