import {
  __privateAdd,
  __privateGet
} from "./chunk.SEHSDSX2.js";

// libs/core/src/utils/controllers/listbox-kb-nav-controller.ts
var _keyboardNavigationHandler;
var ListboxKbNavController = class {
  constructor(host) {
    __privateAdd(this, _keyboardNavigationHandler, (e) => {
      var _a, _b;
      const targetItem = e.target;
      if (!this.host.navigableItems.includes(targetItem))
        return;
      let handled = false;
      if (e.key === "ArrowDown") {
        const nextItemIndex = this.host.navigableItems.indexOf(targetItem) + 1;
        const nextItem = this.host.navigableItems[nextItemIndex];
        nextItem == null ? void 0 : nextItem.focus();
        handled = true;
      } else if (e.key === "ArrowUp") {
        const prevOptionIndex = this.host.navigableItems.indexOf(targetItem) - 1;
        const prevItem = this.host.navigableItems[prevOptionIndex];
        prevItem == null ? void 0 : prevItem.focus();
        handled = true;
      } else if (e.key === "Home") {
        (_a = this.host.navigableItems[0]) == null ? void 0 : _a.focus();
        handled = true;
      } else if (e.key === "End") {
        (_b = this.host.navigableItems[this.host.navigableItems.length - 1]) == null ? void 0 : _b.focus();
        handled = true;
      } else {
        const key = e.key.toLowerCase();
        if (key.length !== 1) {
          return;
        }
        const isLetter = key >= "a" && key <= "z";
        const isNumber = key >= "0" && key <= "9";
        if (isLetter || isNumber) {
          const firstMatch = this.host.navigableItems.find((el) => {
            var _a2;
            const text = (_a2 = el.textContent) == null ? void 0 : _a2.trim().toLowerCase();
            return text == null ? void 0 : text.startsWith(key);
          });
          firstMatch == null ? void 0 : firstMatch.focus();
          handled = true;
        }
      }
      if (handled) {
        e.preventDefault();
        e.stopPropagation();
      }
    });
    ;
    (this.host = host).addController(this);
  }
  hostConnected() {
    this.host.addEventListener("keydown", __privateGet(this, _keyboardNavigationHandler));
  }
  hostDisconnected() {
    this.host.removeEventListener("keydown", __privateGet(this, _keyboardNavigationHandler));
  }
};
_keyboardNavigationHandler = new WeakMap();

// libs/core/src/utils/helpers/unwrap-slots.ts
function unwrap(slotRef) {
  let slot = slotRef;
  while (slot.assignedElements().length > 0 && slot.assignedElements()[0].nodeName === "SLOT") {
    slot = slot.assignedElements()[0];
  }
  return slot;
}

export {
  ListboxKbNavController,
  unwrap
};
