import {
  GdsContainer
} from "./chunk.CIUHRMH7.js";
import {
  styleExpressionProperty
} from "./chunk.K4KPKUH4.js";
import {
  tokens
} from "./chunk.LVFKJRDS.js";
import {
  gdsCustomElement,
  html
} from "./chunk.QK3R23GV.js";
import {
  __decorateClass
} from "./chunk.SEHSDSX2.js";

// libs/core/src/components/card/card.ts
import { css } from "lit";
var GdsCard = class extends GdsContainer {
  /// This sets variables that are used in the default styles. Any other SEPs will override.
  constructor() {
    super();
    this.variant = "primary";
    this.padding = "s; m{l}";
    this["border-radius"] = "xs; m{s}";
    this["border-width"] = "4xs";
  }
  render() {
    return html`<slot></slot>`;
  }
};
GdsCard.styles = [
  tokens,
  css`
      :host {
        border-color: var(--_border-color);
        background-color: var(--_background-color);
        color: var(--_color);
      }
    `
];
__decorateClass([
  styleExpressionProperty({
    property: "box-shadow",
    valueTemplate: (v) => `var(--gds-shadow-${v})`
  })
], GdsCard.prototype, "shadow", 2);
__decorateClass([
  styleExpressionProperty({
    valueTemplate: (v) => v,
    styleTemplate: function(_prop, v) {
      return `
      --_border-color: var(--gds-color-l${this.level}-background-${v});
      --_background-color: var(--gds-color-l${this.level}-background-${v});
      --_color: var(--gds-color-l${this.level}-content-${v});
      `;
    }
  })
], GdsCard.prototype, "variant", 2);
GdsCard = __decorateClass([
  gdsCustomElement("gds-card")
], GdsCard);

export {
  GdsCard
};
