import {
  styleExpressionProperty
} from "./chunk.K4KPKUH4.js";
import {
  forwardAttributes
} from "./chunk.76CTWWTO.js";
import {
  GdsFormControlElement
} from "./chunk.VA6TUMR2.js";
import {
  watch
} from "./chunk.TYGMNHNO.js";
import {
  tokens
} from "./chunk.LVFKJRDS.js";
import {
  gdsCustomElement,
  html
} from "./chunk.QK3R23GV.js";
import {
  __decorateClass,
  __privateAdd,
  __privateGet,
  __privateMethod
} from "./chunk.SEHSDSX2.js";

// libs/core/src/components/textarea/textarea.ts
import { localized, msg } from "@lit/localize";
import { property, query, queryAsync } from "lit/decorators.js";
import { choose } from "lit/directives/choose.js";
import { when } from "lit/directives/when.js";
import { nothing } from "lit/html.js";

// libs/core/src/components/textarea/textarea.styles.ts
import { css } from "lit";
var styles = css`
  @layer base, simplified;

  @layer base {
    * {
      box-sizing: border-box;
    }

    :host {
      display: flex;
      flex-direction: column;
      width: 100%;
      contain: layout;
      isolation: isolate;
      gap: var(--gds-space-xs);
    }

    textarea {
      appearance: none;
      background-color: transparent;
      border: 0;
      box-sizing: border-box;
      font-family: inherit;
      font-size: var(--gds-text-size-detail-m);
      height: calc(1lh * var(--_lines));
      line-height: var(--gds-text-line-height-detail-m);
      margin: unset;
      min-height: calc(1lh * 4);
      outline: none;
      overflow: hidden;
      padding: unset;
      resize: none;
      transition:
        var(--_transition),
        resize 0s;

      width: 100%;
    }

    :host([size='small']) slot[name='lead']::slotted(*) {
      width: var(--gds-space-m);
    }

    slot[name='lead']::slotted(*) {
      min-width: var(--gds-space-l);
      display: flex;
    }

    [align-items] ::part(_button) {
      margin-top: calc(var(--gds-space-2xs) * -1);
    }

    .resize-handle {
      position: absolute;
      inset: auto auto -10px 0;
      width: 100%;
      height: 20px;
      cursor: row-resize;
      z-index: 2;
      &:hover,
      &:active {
        &::before {
          width: 22px;
          opacity: 1;
          height: 1px;
        }
      }
      &::before {
        content: '';
        position: absolute;
        background: currentColor;
        inset: 0;
        margin-inline: auto;
        height: 0px;
        width: 12px;
        opacity: 0;
        border-radius: 100px;
        transition: var(--_transition);
      }
    }
  }

  @layer simplified {
  }
`;

// libs/core/src/components/textarea/textarea.ts
var _renderDefault, renderDefault_fn, _renderFloatingLabel, renderFloatingLabel_fn, _forwardableAttrs, _handleOnInput, _handleOnChange, _handleFieldClick, _handleClearBtnClick, _renderFieldContents, renderFieldContents_fn, _renderSlotLead, renderSlotLead_fn, _renderSlotTrail, renderSlotTrail_fn, _addResizeHandleListener, addResizeHandleListener_fn, _resizeState, _startDragging, _onDrag, _stopDragging, _renderResizeHandle, renderResizeHandle_fn, _renderNativeTextarea, renderNativeTextarea_fn, _renderClearButton, renderClearButton_fn, _shouldShowRemainingChars, shouldShowRemainingChars_get;
var GdsTextarea = class extends GdsFormControlElement {
  constructor() {
    super();
    __privateAdd(this, _renderDefault);
    // variant="floatingLabel"
    __privateAdd(this, _renderFloatingLabel);
    __privateAdd(this, _renderFieldContents);
    __privateAdd(this, _renderSlotLead);
    __privateAdd(this, _renderSlotTrail);
    __privateAdd(this, _addResizeHandleListener);
    __privateAdd(this, _renderResizeHandle);
    __privateAdd(this, _renderNativeTextarea);
    __privateAdd(this, _renderClearButton);
    __privateAdd(this, _shouldShowRemainingChars);
    this.rows = 4;
    this.supportingText = "";
    this.clearable = false;
    this.resize = "auto";
    this.maxlength = Number.MAX_SAFE_INTEGER;
    this.variant = "default";
    // Any attribute name added here will get forwarded to the native <input> element.
    __privateAdd(this, _forwardableAttrs, (attr) => ["type", "placeholder", "required"].includes(attr.name));
    __privateAdd(this, _handleOnInput, (e) => {
      const element = e.target;
      this.value = element.value;
    });
    __privateAdd(this, _handleOnChange, (e) => {
      const element = e.target;
      this.value = element.value;
      this.dispatchEvent(
        new Event("change", {
          bubbles: true,
          composed: true
        })
      );
    });
    __privateAdd(this, _handleFieldClick, () => {
      this.elTextareaAsync.then((el) => el.focus());
    });
    __privateAdd(this, _handleClearBtnClick, () => {
      this.value = "";
      this.dispatchEvent(
        new Event("gds-input-cleared", {
          bubbles: true,
          composed: true
        })
      );
      this.dispatchEvent(
        new Event("input", {
          bubbles: true,
          composed: true
        })
      );
    });
    // State for the resize handle action
    __privateAdd(this, _resizeState, {
      isDragging: false,
      startMouseY: 0,
      lines: this.rows,
      deltaLines: 0,
      lineHeight: 0
    });
    __privateAdd(this, _startDragging, (event) => {
      event.preventDefault();
      __privateGet(this, _resizeState).isDragging = true;
      __privateGet(this, _resizeState).startMouseY = event.clientY;
      __privateGet(this, _resizeState).lineHeight = parseFloat(
        getComputedStyle(this.elTextarea).lineHeight
      );
      document.addEventListener("mousemove", __privateGet(this, _onDrag));
      document.addEventListener("mouseup", __privateGet(this, _stopDragging));
    });
    __privateAdd(this, _onDrag, (event) => {
      if (!__privateGet(this, _resizeState).isDragging)
        return;
      const deltaY = event.clientY - __privateGet(this, _resizeState).startMouseY;
      __privateGet(this, _resizeState).deltaLines = Math.round(
        deltaY / __privateGet(this, _resizeState).lineHeight
      );
      this.elTextareaAsync.then((element) => {
        element == null ? void 0 : element.style.setProperty(
          "--_lines",
          (__privateGet(this, _resizeState).lines + __privateGet(this, _resizeState).deltaLines).toString()
        );
      });
    });
    __privateAdd(this, _stopDragging, () => {
      __privateGet(this, _resizeState).isDragging = false;
      __privateGet(this, _resizeState).lines += __privateGet(this, _resizeState).deltaLines;
      this.rows = __privateGet(this, _resizeState).lines;
      __privateGet(this, _resizeState).deltaLines = 0;
      document.removeEventListener("mousemove", __privateGet(this, _onDrag));
      document.removeEventListener("mouseup", __privateGet(this, _stopDragging));
    });
    this.value = "";
  }
  /**
   * A reference to the clear button element. Returns null if there is no clear button.
   * Intended for use in integration tests.
   */
  test_getClearButton() {
    var _a;
    return (_a = this.shadowRoot) == null ? void 0 : _a.querySelector("#clear-button");
  }
  /**
   * A reference to the field element. This does not refer to the input element itself,
   * but the wrapper that makes up the visual field.
   * Intended for use in integration tests.
   */
  test_getFieldElement() {
    var _a;
    return (_a = this.shadowRoot) == null ? void 0 : _a.querySelector("#field");
  }
  connectedCallback() {
    super.connectedCallback();
    this._setAutoHeight();
    __privateMethod(this, _addResizeHandleListener, addResizeHandleListener_fn).call(this);
  }
  disconnectedCallback() {
    super.disconnectedCallback();
    __privateGet(this, _stopDragging).call(this);
  }
  render() {
    return html`${choose(this.variant, [
      ["default", () => __privateMethod(this, _renderDefault, renderDefault_fn).call(this)],
      ["floating-label", () => __privateMethod(this, _renderFloatingLabel, renderFloatingLabel_fn).call(this)]
    ])}`;
  }
  _getValidityAnchor() {
    return this.elTextarea;
  }
  _setAutoHeight() {
    this.elTextareaAsync.then((element) => {
      this.rows = Math.max(this.rows, element.value.split("\n").length);
      __privateGet(this, _resizeState).lines = Number(this.rows);
      element == null ? void 0 : element.style.setProperty("--_lines", this.rows.toString());
    });
  }
};
_renderDefault = new WeakSet();
renderDefault_fn = function() {
  var _a;
  return html`
      <gds-form-control-header>
        <label for="input" slot="label">${this.label}</label>
        <span slot="supporting-text" id="supporting-text">
          ${this.supportingText}
        </span>
        <slot
          name="extended-supporting-text"
          slot="extended-supporting-text"
        ></slot>
      </gds-form-control-header>

      <gds-field-base
        id="field"
        .disabled=${this.disabled}
        .invalid=${this.invalid}
        @click=${__privateGet(this, _handleFieldClick)}
        multiline
      >
        ${__privateMethod(this, _renderFieldContents, renderFieldContents_fn).call(this)}
        ${when(
    this.resize === "auto",
    () => __privateMethod(this, _renderResizeHandle, renderResizeHandle_fn).call(this),
    () => nothing
  )}
      </gds-field-base>

      <gds-form-control-footer
        .charCounter=${__privateGet(this, _shouldShowRemainingChars, shouldShowRemainingChars_get) && this.maxlength - (((_a = this.value) == null ? void 0 : _a.length) || 0)}
        .validationMessage=${this.invalid && (this.errorMessage || this.validationMessage)}
      ></gds-form-control-footer>
    `;
};
_renderFloatingLabel = new WeakSet();
renderFloatingLabel_fn = function() {
  return nothing;
};
_forwardableAttrs = new WeakMap();
_handleOnInput = new WeakMap();
_handleOnChange = new WeakMap();
_handleFieldClick = new WeakMap();
_handleClearBtnClick = new WeakMap();
_renderFieldContents = new WeakSet();
renderFieldContents_fn = function() {
  const elements = [
    __privateMethod(this, _renderSlotLead, renderSlotLead_fn).call(this),
    __privateMethod(this, _renderNativeTextarea, renderNativeTextarea_fn).call(this),
    __privateMethod(this, _renderClearButton, renderClearButton_fn).call(this),
    __privateMethod(this, _renderSlotTrail, renderSlotTrail_fn).call(this)
  ];
  return elements.map((element) => html`${element}`);
};
_renderSlotLead = new WeakSet();
renderSlotLead_fn = function() {
  return html`<slot slot="lead" name="lead"></slot>`;
};
_renderSlotTrail = new WeakSet();
renderSlotTrail_fn = function() {
  return html`<slot slot="trail" name="trail"></slot>`;
};
_addResizeHandleListener = new WeakSet();
addResizeHandleListener_fn = function() {
  const resizeHandle = this.querySelector(".resize-handle");
  if (resizeHandle) {
    resizeHandle.addEventListener(
      "mousedown",
      __privateGet(this, _startDragging)
    );
  }
};
_resizeState = new WeakMap();
_startDragging = new WeakMap();
_onDrag = new WeakMap();
_stopDragging = new WeakMap();
_renderResizeHandle = new WeakSet();
renderResizeHandle_fn = function() {
  return html`
      <div class="resize-handle" @mousedown=${__privateGet(this, _startDragging)}></div>
    `;
};
_renderNativeTextarea = new WeakSet();
renderNativeTextarea_fn = function() {
  return html`
      <textarea
        @input=${__privateGet(this, _handleOnInput)}
        @change=${__privateGet(this, _handleOnChange)}
        .value=${this.value}
        id="input"
        aria-describedby="supporting-text extended-supporting-text sub-label message"
        placeholder=" "
        ${forwardAttributes(__privateGet(this, _forwardableAttrs))}
      ></textarea>
    `;
};
_renderClearButton = new WeakSet();
renderClearButton_fn = function() {
  var _a;
  if (this.clearable && (((_a = this.value) == null ? void 0 : _a.length) || 0) > 0)
    return html`
        <gds-button
          size="small"
          rank="tertiary"
          variant="${this.invalid ? "negative" : ""}"
          ?disabled="${this.disabled}"
          label="${msg("Clear input")}"
          @click=${__privateGet(this, _handleClearBtnClick)}
          slot="action"
          id="clear-button"
        >
          <gds-icon-cross-large />
        </gds-button>
      `;
  else
    return nothing;
};
_shouldShowRemainingChars = new WeakSet();
shouldShowRemainingChars_get = function() {
  return this.maxlength < Number.MAX_SAFE_INTEGER;
};
GdsTextarea.styles = [tokens, styles];
__decorateClass([
  styleExpressionProperty({
    valueTemplate: (v) => v,
    selector: "textarea",
    styleTemplate: (_prop, values) => {
      const ROWS = values[0];
      return `min-height: calc(1lh * ${ROWS});`;
    }
  })
], GdsTextarea.prototype, "rows", 2);
__decorateClass([
  property({ attribute: "supporting-text" })
], GdsTextarea.prototype, "supportingText", 2);
__decorateClass([
  property({ type: Boolean })
], GdsTextarea.prototype, "clearable", 2);
__decorateClass([
  property()
], GdsTextarea.prototype, "resize", 2);
__decorateClass([
  property({ type: Number })
], GdsTextarea.prototype, "maxlength", 2);
__decorateClass([
  property({ type: String })
], GdsTextarea.prototype, "variant", 2);
__decorateClass([
  queryAsync("textarea")
], GdsTextarea.prototype, "elTextareaAsync", 2);
__decorateClass([
  query("textarea")
], GdsTextarea.prototype, "elTextarea", 2);
__decorateClass([
  watch("value")
], GdsTextarea.prototype, "_setAutoHeight", 1);
GdsTextarea = __decorateClass([
  gdsCustomElement("gds-textarea"),
  localized()
], GdsTextarea);

export {
  GdsTextarea
};
