import {
  styleExpressionProperty
} from "./chunk.K4KPKUH4.js";
import {
  tokens
} from "./chunk.LVFKJRDS.js";
import {
  GdsElement
} from "./chunk.TMEWQZER.js";
import {
  gdsCustomElement,
  html
} from "./chunk.QK3R23GV.js";
import {
  __decorateClass
} from "./chunk.SEHSDSX2.js";

// libs/core/src/components/divider/divider.ts
import { property } from "lit/decorators.js";

// libs/core/src/components/divider/divider.style.ts
import { css } from "lit";
var style = css`
  :host {
    display: block;
  }

  hr {
    border-radius: 200px;
    background: currentColor;
    font-size: 0;
    border: 0;
    height: 1px;
    width: 100%;
    margin-top: calc((var(--_size, 0) / 2) - (1px / 2));
    margin-bottom: calc((var(--_size, 0) / 2) - (1px / 2));
  }
`;
var divider_style_default = style;

// libs/core/src/components/divider/divider.ts
var GdsDivider = class extends GdsElement {
  constructor() {
    super(...arguments);
    this.level = "2";
  }
  render() {
    return html`<hr />`;
  }
};
GdsDivider.styles = [tokens, divider_style_default];
__decorateClass([
  property()
], GdsDivider.prototype, "level", 2);
__decorateClass([
  styleExpressionProperty({
    valueTemplate: function(v) {
      const [colorInput, transparency] = v.split("/");
      const isCustomColor = (color) => {
        const trimmedColor = color.trim();
        return trimmedColor.startsWith("#") || // Hex color
        trimmedColor.startsWith("rgb(") || // RGB color
        trimmedColor.startsWith("rgba(") || // RGBA color
        trimmedColor.startsWith("hsl(") || // HSL color
        trimmedColor.startsWith("hsla(");
      };
      const constructCssVariable = (level, colorName) => {
        return `var(--gds-color-l${level}-border-${colorName})`;
      };
      const getColorValue = (color, transparency2) => {
        if (isCustomColor(color)) {
          return transparency2 ? `color-mix(in srgb, ${color} ${parseFloat(transparency2) * 100}%, transparent 0%)` : color;
        } else {
          return constructCssVariable(this.level, color);
        }
      };
      return getColorValue(colorInput, transparency);
    }
  })
], GdsDivider.prototype, "color", 2);
__decorateClass([
  styleExpressionProperty({
    property: "--_size",
    valueTemplate: (v) => `var(--gds-space-${v})`
  })
], GdsDivider.prototype, "size", 2);
__decorateClass([
  styleExpressionProperty({
    property: "opacity",
    valueTemplate: (v) => v
  })
], GdsDivider.prototype, "opacity", 2);
GdsDivider = __decorateClass([
  gdsCustomElement("gds-divider")
], GdsDivider);

export {
  GdsDivider
};
