import { GdsElement } from '../../gds-element';
import '../flex';
/**
 * `gds-badge`
 *
 * @element gds-badge
 * @status beta
 *
 */
export declare class GdsBadge extends GdsElement {
    #private;
    static styles: (import("lit").CSSResult | import("lit").CSSResult[])[];
    /**
     * Controls the variant of the badge.
     * Supports all valid variants like information, notice, positive, warning, negative.
     * @property variant
     */
    variant: string;
    /**
     * Defines the size of the badge.
     * The default value is `default`.
     *
     * @property {string} size - The size of the badge, which can be either 'default' or 'small'.
     */
    size: 'default' | 'small';
    /**
     * Indicates whether the badge is disabled.
     * When set to `true`, the badge will appear in a disabled state and will not be interactive.
     *
     * @property {boolean} disabled - Controls the disabled state of the badge.
     */
    disabled: boolean;
    /**
     * Indicates whether the badge is in notification mode.
     * When set to `true`, the badge will act as a notification badge with only two variants: `positive` or `negative`.
     *
     * @property {boolean} notification - Controls the notification mode of the badge.
     */
    notification: boolean;
    /**
     * Indicates whether the badge is rounded.
     *
     * @property {boolean} rounded - Controls the border radius of the badge.
     */
    rounded: boolean;
    mainSlotOccupied: boolean;
    constructor();
    render(): any;
}
