import { LitElement } from 'lit';
import { DynamicStylesController } from './utils/controllers/dynamic-styles-controller';
import 'reflect-metadata';
export declare class GdsElement extends LitElement {
    /**
     * The unscoped name of this element. This attribute is set automatically by the element and is inteded to be read-only.
     *
     * @attribute gds-element
     * @readonly
     */
    gdsElementName?: string;
    /**
     * Whether the element is using transitional styles.
     * @internal
     */
    _isUsingTransitionalStyles: boolean;
    /**
     * @private
     */
    _dynamicStylesController: DynamicStylesController;
    constructor();
    connectedCallback(): void;
    disconnectedCallback(): void;
}
