import type { LitElement } from 'lit';
type Handler = () => void;
/**
 * Runs when the size of the component changes.
 *
 * Usage:
 * ```javascript
 * \@resizeObserver()
 * handleResize() {
 *  // Do some layout calculation or something
 * }
 * ```
 */
export declare function resizeObserver(): <ElemClass extends LitElement>(proto: ElemClass, propertyKey: string, descriptor: TypedPropertyDescriptor<Handler>) => void;
export {};
