import { targetLocales } from '../../generated/locale-codes';
import * as templates_sv from '../../generated/locales/sv';
declare const localizedTemplates: Map<string, typeof templates_sv>;
type LocalizationConfig = {
    extraLocales: string[];
    extraTemplates: typeof localizedTemplates;
};
/**
 * A list of available built-in locales
 */
export { targetLocales };
/**
 * Initializes localization for Green Core. This is a wrapper around Lit's `configureLocalization`,
 * which adds the ability to add extra locales and templates.
 *
 * @param extraLocales - Extra locales to add to the list of target locales
 * @param extraTemplates - Extra templates to add to the list of localized templates
 */
export declare const gdsInitLocalization: ({ extraLocales, extraTemplates }?: LocalizationConfig) => {
    getLocale: (() => string) & {
        _LIT_LOCALIZE_GET_LOCALE_?: undefined;
    };
    setLocale: ((newLocale: string) => Promise<void>) & {
        _LIT_LOCALIZE_SET_LOCALE_?: undefined;
    };
};
